from libcpp cimport bool as c_bool

cdef extern from "escape/core.h" namespace "escape::core":
    cdef cppclass array_t[T]:
        array_t()
        array_t(size_t)
        array_t(size_t, T *, c_bool)
        array_t(array_t) except+
        inline size_t size() except +
        size_t nrows() except +
        size_t ncols() except +
        void reshape(size_t, size_t) except +
        void fill(T) except +
        void copy(array_t[T]) except +
        T get(size_t idx) except +
        void set(size_t idx, T val) except +
        T * data() except +

ctypedef array_t[double] double_array_t
ctypedef array_t[c_bool] bool_array_t

cdef class double_array_obj:
    cdef double_array_t * _ptr 
    cdef set_ptr(self, double_array_t * ptr)
    cdef copy (self, double_array_t ptr)
    @staticmethod
    cdef double_array_obj from_ptr(double_array_t *_ptr)
    
cdef class mask_array_obj:
    cdef bool_array_t * _ptr 
    cdef copy (self, bool_array_t ptr)
    cdef set_ptr(self, bool_array_t * ptr)
    @staticmethod
    cdef mask_array_obj from_ptr(bool_array_t *_ptr)


cdef extern from "escape/core.h" namespace "escape":
    double_array_t cpp_create_double_array_ptr "escape::array<double>" (
        size_t, double *)
    bool_array_t cpp_create_mask_array_ptr "escape::array<bool>" (
        size_t, c_bool *)
