from libcpp.string cimport string as c_string
from libcpp cimport bool as c_bool

from escape.core.variable cimport variable_t
from escape.core.functor cimport functor_t
from escape.core.setting cimport double_setting_t, int_setting_t
from escape.core.parameter cimport parameter_t

cdef extern from "escape/core.h" namespace "escape":
    functor_t cpp_gamma_p "escape::gamma"(c_string, variable_t, parameter_t, parameter_t ) except+
    functor_t cpp_gamma_f "escape::gamma"(c_string, variable_t, variable_t, functor_t ) except+
    
    functor_t cpp_schulz_p "escape::schulz"(c_string, variable_t, parameter_t, parameter_t ) except+
    functor_t cpp_schulz_f "escape::schulz"(c_string, variable_t, variable_t, functor_t ) except+
    
    functor_t cpp_lognorm_p "escape::lognorm"(c_string, variable_t, parameter_t, parameter_t ) except+
    functor_t cpp_lognorm_f "escape::lognorm"(c_string, variable_t, variable_t, functor_t ) except+
    
    functor_t cpp_normal_p "escape::normal"(c_string, variable_t, parameter_t, parameter_t ) except+
    functor_t cpp_normal_f "escape::normal"(c_string, variable_t, variable_t, functor_t ) except+
    
    functor_t cpp_uniform_p "escape::uniform"(c_string, variable_t, parameter_t, parameter_t ) except+
    functor_t cpp_uniform_f "escape::uniform"(c_string, variable_t, variable_t, functor_t ) except+
    
    functor_t cpp_triangular_p "escape::triangular"(c_string, variable_t, parameter_t, parameter_t ) except+
    functor_t cpp_triangular_f "escape::triangular"(c_string, variable_t, variable_t, functor_t ) except+
    
    functor_t cpp_convolution_ffp_7 "escape::convolution<7>"  (functor_t, functor_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_ffp_15 "escape::convolution<15>"(functor_t, functor_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_ffp_21 "escape::convolution<21>"(functor_t, functor_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_ffp_31 "escape::convolution<31>"(functor_t, functor_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_ffp_51 "escape::convolution<51>"(functor_t, functor_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_ffp_61 "escape::convolution<61>"(functor_t, functor_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    
    functor_t cpp_convolution_fpp_7 "escape::convolution<7>"  (functor_t, parameter_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_fpp_15 "escape::convolution<15>"(functor_t, parameter_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_fpp_21 "escape::convolution<21>"(functor_t, parameter_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_fpp_31 "escape::convolution<31>"(functor_t, parameter_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_fpp_51 "escape::convolution<51>"(functor_t, parameter_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_fpp_61 "escape::convolution<61>"(functor_t, parameter_t, parameter_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    
    
    functor_t cpp_convolution_7 "escape::convolution<7>"  (functor_t, functor_t, variable_t, variable_t, functor_t, functor_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_15 "escape::convolution<15>"(functor_t, functor_t, variable_t, variable_t, functor_t, functor_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_21 "escape::convolution<21>"(functor_t, functor_t, variable_t, variable_t, functor_t, functor_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_31 "escape::convolution<31>"(functor_t, functor_t, variable_t, variable_t, functor_t, functor_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_51 "escape::convolution<51>"(functor_t, functor_t, variable_t, variable_t, functor_t, functor_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_convolution_61 "escape::convolution<61>"(functor_t, functor_t, variable_t, variable_t, functor_t, functor_t, double_setting_t, double_setting_t, int_setting_t) except+
    
    
    