from libcpp.string cimport string as c_string
from libcpp cimport bool as c_bool

from escape.core.array cimport array_t, double_array_t, bool_array_t
from escape.core.parameter cimport parameter_t

cdef extern from "escape/core.h" namespace "escape::core":

    cdef cppclass data_t:
        data_t()
        data_t(data_t  ) except+

        double_array_t coordinates() except +
        double_array_t intensities() except +
        double_array_t errors() except +
        bool_array_t mask() except +
        
        double_array_t ini_coordinates() except +
        double_array_t ini_intensities() except +
        double_array_t ini_errors() except +

        void set_mask(bool_array_t  ) except +
        void reset_mask() except +

        size_t size() except +
        size_t dimensionality() except +

        c_string name() except +
        void set_name(c_string   ) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        
    cdef cppclass datastack_t:

        datastack_t()
        datastack_t(datastack_t) except+
        
        void add(data_t)
        void set(size_t idx, data_t)

        size_t size()
        
        void erase(size_t idx)
        void erase_all()

        int data_length() except +
        data_t data(size_t) except +

        c_string name() except +
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +

        

    data_t cpp_create_data "escape::data" (c_string, double_array_t, double_array_t) except+
    data_t cpp_create_data_err "escape::data" (c_string, double_array_t, double_array_t, double_array_t) except+
    datastack_t cpp_create_datastack "escape::datastack"(c_string) except +
    datastack_t cpp_create_datastack2 "escape::datastack"(c_string, data_t) except +


cdef class data_obj:
    cdef data_t * _ptr
    cdef set_ptr(self, data_t * ptr)
    @staticmethod
    cdef data_obj from_ptr(data_t *_ptr)
    
cdef class datastack_obj:

    cdef datastack_t * _ptr
    cdef set_ptr(self, datastack_t * ptr)
    
    @staticmethod
    cdef datastack_obj from_ptr(datastack_t *_ptr)
    