from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string
from libcpp.vector cimport vector

from escape.core.parameter cimport parameter_t
from escape.core.variable cimport variable_t
from escape.core.setting cimport double_setting_t


cdef extern from "escape/core.h" namespace "escape":
    cdef cppclass bool_functor_t:
        bool_functor_t()
        bool_functor_t(bool_functor_t) except +
        c_bool call_1 "operator()" (double) except +
        c_bool call_2 "operator()" (double, double) except +
        c_bool call_3 "operator()" (double, double, double) except +
        c_bool call_4 "operator()" (double, double, double, double) except +
        c_bool call_5 "operator()" (double, double, double, double, double) except +
        
        c_string name() except +
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        
        
        vector[variable_t] variables() except +
        size_t dimensionality() except +
        
        bool_functor_t logic_and "operator &&" (bool_functor_t) except +
        bool_functor_t logic_or "operator ||" (bool_functor_t) except +
        bool_functor_t logic_not "operator !" () except +

cdef extern from "escape/core.h" namespace "escape":
    cdef cppclass functor_t:
        functor_t()
        functor_t(functor_t) except +
        double call_1 "operator()" (double) except +
        double call_2 "operator()" (double, double) except +
        double call_3 "operator()" (double, double, double) except +
        double call_4 "operator()" (double, double, double, double) except +
        double call_5 "operator()" (double, double, double, double, double) except +

        functor_t operator - () except +
        functor_t operator + (functor_t) except +
        functor_t operator - (functor_t) except +
        functor_t operator * (functor_t) except +
        functor_t operator / (functor_t) except +

        bool_functor_t operator > (functor_t) except +
        bool_functor_t operator >= (functor_t) except +
        bool_functor_t operator < (functor_t) except +
        bool_functor_t operator <= (functor_t) except +
        bool_functor_t operator == (functor_t) except +
        bool_functor_t operator != (functor_t) except +
        
        vector[variable_t] variables() except +
        size_t dimensionality() except +

        c_string name() except +
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        
cdef extern from "escape/core.h" namespace "escape":
    cdef cppclass cplx_functor_t:
        cplx_functor_t()
        cplx_functor_t(cplx_functor_t) except +
        double complex call_1 "operator()" (double) except +
        double complex call_2 "operator()" (double, double) except +
        double complex call_3 "operator()" (double, double, double) except +
        double complex call_4 "operator()" (double, double, double, double) except +
        double complex call_5 "operator()" (double, double, double, double, double) except +

        cplx_functor_t operator - () except +

        cplx_functor_t operator + (cplx_functor_t) except +
        cplx_functor_t operator - (cplx_functor_t) except +
        cplx_functor_t operator * (cplx_functor_t) except +
        cplx_functor_t operator / (cplx_functor_t) except +

        bool_functor_t operator == (cplx_functor_t) except +
        bool_functor_t operator != (cplx_functor_t) except +
        
        vector[variable_t] variables() except +
        size_t dimensionality() except +

        c_string name() except +
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        

cdef extern from "escape/core.h" namespace "escape":
    functor_t cpp_identity_functor "escape::func"(c_string, variable_t var) except+
    functor_t cpp_const_functor_1 "escape::func"(variable_t x0, parameter_t) except+
    functor_t cpp_const_functor_2 "escape::func"(variable_t x0, variable_t x1, parameter_t) except+
    functor_t cpp_const_functor_3 "escape::func"(variable_t x0, variable_t x1, variable_t x2, parameter_t) except+
    functor_t cpp_const_functor_4 "escape::func"(variable_t x0, variable_t x1, variable_t x2, variable_t x3, parameter_t) except+
    functor_t cpp_const_functor_5 "escape::func"(variable_t x0, variable_t x1, variable_t x2, variable_t x3, variable_t x4, parameter_t) except+
    
    cplx_functor_t cpp_const_cfunctor_1 "escape::cfunc"(variable_t x0, double complex) except+
    cplx_functor_t cpp_const_cfunctor_2 "escape::cfunc"(variable_t x0, variable_t x1, double complex) except+
    cplx_functor_t cpp_const_cfunctor_3 "escape::cfunc"(variable_t x0, variable_t x1, variable_t x2, double complex) except+
    cplx_functor_t cpp_const_cfunctor_4 "escape::cfunc"(variable_t x0, variable_t x1, variable_t x2, variable_t x3, double complex) except+
    cplx_functor_t cpp_const_cfunctor_5 "escape::cfunc"(variable_t x0, variable_t x1, variable_t x2, variable_t x3, variable_t x4, double complex) except+
    
    functor_t cpp_reduce_1 "escape::reduce"(functor_t func, variable_t x0, parameter_t val0) except+
    functor_t cpp_reduce_2 "escape::reduce"(functor_t func, variable_t x0, parameter_t val0, variable_t x1, parameter_t val1) except+
    functor_t cpp_reduce_3 "escape::reduce"(functor_t func, variable_t x0, parameter_t val0, variable_t x1, parameter_t val1, variable_t x2, parameter_t val2) except+
    functor_t cpp_reduce_4 "escape::reduce"(functor_t func, variable_t x0, parameter_t val0, variable_t x1, parameter_t val1, variable_t x2, parameter_t val2, variable_t x3, parameter_t val3) except+
    
    cplx_functor_t cpp_creduce_1 "escape::reduce"(cplx_functor_t func, variable_t x0, parameter_t val0) except+
    cplx_functor_t cpp_creduce_2 "escape::reduce"(cplx_functor_t func, variable_t x0, parameter_t val0, variable_t x1, parameter_t val1) except+
    cplx_functor_t cpp_creduce_3 "escape::reduce"(cplx_functor_t func, variable_t x0, parameter_t val0, variable_t x1, parameter_t val1, variable_t x2, parameter_t val2) except+
    cplx_functor_t cpp_creduce_4 "escape::reduce"(cplx_functor_t func, variable_t x0, parameter_t val0, variable_t x1, parameter_t val1, variable_t x2, parameter_t val2, variable_t x3, parameter_t val3) except+

    functor_t cpp_rotate_2d "escape::rotate"(functor_t func, variable_t x0, variable_t x1, parameter_t adeg) except+
    cplx_functor_t cpp_crotate_2d "escape::rotate"(cplx_functor_t func, variable_t x0, variable_t x1, parameter_t adeg) except+

    functor_t cpp_conditional_functor "escape::conditional"(c_string, bool_functor_t, functor_t, functor_t) except+    
    functor_t cpp_scale_functor "escape::scale_functor"(c_string, functor_t, parameter_t, parameter_t, parameter_t, parameter_t) except+
    functor_t cpp_scale_functor_01 "escape::scale_functor"(c_string, functor_t, parameter_t, parameter_t) except+
    
    
    


