from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.core.array cimport double_array_t
from escape.core.parameter cimport parameter_t
from escape.core.functor cimport functor_t

cdef extern from "escape/core.h" namespace "escape":
    cdef cppclass kernel_t:
        kernel_t()
        kernel_t(kernel_t   ) except+
        void call "operator()" (double_array_t  , double_array_t   ) except+
        
        kernel_t operator - () except +
        kernel_t operator + (kernel_t) except +
        kernel_t operator - (kernel_t) except +
        kernel_t operator * (kernel_t) except +
        kernel_t operator / (kernel_t) except +
        void shake() except +
        size_t dimensionality() except +
        
        c_string name() except +
        void set_name(c_string   ) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +


cdef extern from "escape/core.h" namespace "escape":
    kernel_t cpp_functor_kernel "escape::kernel"(c_string, functor_t, c_bool) except+

