from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.core.array cimport double_array_t
from escape.core.variable cimport variable_t
from escape.core.parameter cimport parameter_t
from escape.core.functor cimport functor_t, cplx_functor_t 
from escape.core.setting cimport double_setting_t, int_setting_t


cdef extern from "escape/core.h" namespace "escape":
    cdef cppclass vector_t:
        vector_t()


cdef extern from "escape/core.h" namespace "escape":
    
    functor_t cpp_sin_f "escape::sin"(functor_t) except+
    cplx_functor_t cpp_sin_cf "escape::sin"(cplx_functor_t) except+

    functor_t cpp_cos_f "escape::cos"(functor_t) except+
    cplx_functor_t cpp_cos_cf "escape::cos"(cplx_functor_t) except+

    functor_t cpp_tan_f "escape::tan"(functor_t) except+
    cplx_functor_t cpp_tan_cf "escape::tan"(cplx_functor_t) except+

    functor_t cpp_sinh_f "escape::sinh"(functor_t) except+
    cplx_functor_t cpp_sinh_cf "escape::sinh"(cplx_functor_t) except+

    functor_t cpp_cosh_f "escape::cosh"(functor_t) except+
    cplx_functor_t cpp_cosh_cf "escape::cosh"(cplx_functor_t) except+

    functor_t cpp_tanh_f "escape::tanh"(functor_t) except+
    cplx_functor_t cpp_tanh_cf "escape::tanh"(cplx_functor_t) except+

    functor_t cpp_exp_f "escape::exp"(functor_t) except+
    cplx_functor_t cpp_exp_cf "escape::exp"(cplx_functor_t) except+
    
    functor_t cpp_abs_f "escape::abs"(functor_t) except+


    functor_t cpp_log_f "escape::log"(functor_t) except+
    functor_t cpp_log10_f "escape::log10"(functor_t) except+

    functor_t cpp_sqrt_f "escape::sqrt"(functor_t) except+
    cplx_functor_t cpp_sqrt_cf "escape::sqrt"(cplx_functor_t) except+

    functor_t cpp_erf_f "escape::erf"(functor_t) except+
    
    functor_t cpp_pow_f "escape::pow"(functor_t, functor_t) except+
    functor_t cpp_pow_vv "escape::pow"(variable_t, variable_t) except+
    functor_t cpp_pow_vf "escape::pow"(variable_t, functor_t) except+
    functor_t cpp_pow_fv "escape::pow"(functor_t, variable_t) except+
    
    functor_t cpp_min_f "escape::min"(functor_t, functor_t) except+
    functor_t cpp_max_f "escape::max"(functor_t, functor_t) except+
    
    functor_t cpp_norm_cf "escape::norm"(cplx_functor_t) except+
    functor_t cpp_norm_f "escape::norm"(functor_t) except+
    
    functor_t cpp_arg_cf "escape::arg"(cplx_functor_t) except+
    functor_t cpp_arg_f "escape::arg"(functor_t) except+
    
    functor_t cpp_imag_cf "escape::imag"(cplx_functor_t) except+
    functor_t cpp_imag_f "escape::imag"(functor_t) except+
    
    functor_t cpp_real_cf "escape::real"(cplx_functor_t) except+
    functor_t cpp_real_f "escape::real"(functor_t) except+
    
    functor_t cpp_abs_cf "escape::abs"(cplx_functor_t) except+
    
    cplx_functor_t cpp_conj_cf "escape::conj"(cplx_functor_t) except+
    cplx_functor_t cpp_conj_f "escape::conj"(functor_t) except+
    
    functor_t cpp_tgamma_f "escape::tgamma"(functor_t) except+
    functor_t cpp_gammap_f "escape::gamma_p"(parameter_t, functor_t) except+
    functor_t cpp_gammaq_f "escape::gamma_q"(parameter_t, functor_t) except+
    functor_t cpp_tgammal_f "escape::tgamma_lower"(parameter_t, functor_t) except+
    functor_t cpp_tgammau_f "escape::tgamma_upper"(parameter_t, functor_t) except+
    
    functor_t cpp_linterp_f "escape::linterp"(functor_t, double_array_t, double_array_t) except+
    functor_t cpp_cyl_bessel_j_f "escape::cyl_bessel_j"(parameter_t, functor_t) except+
    

    parameter_t cpp_sin_p "escape::sin"(parameter_t) except+
    parameter_t cpp_cos_p "escape::cos"(parameter_t) except+
    parameter_t cpp_tan_p "escape::tan"(parameter_t) except+
    parameter_t cpp_sinh_p "escape::sinh"(parameter_t) except+
    parameter_t cpp_cosh_p "escape::cosh"(parameter_t) except+
    parameter_t cpp_tanh_p "escape::tanh"(parameter_t) except+
    parameter_t cpp_exp_p "escape::exp"(parameter_t) except+
    parameter_t cpp_abs_p "escape::abs"(parameter_t) except+
    parameter_t cpp_log_p "escape::log"(parameter_t) except+
    parameter_t cpp_log10_p "escape::log10"(parameter_t) except+
    parameter_t cpp_sqrt_p "escape::sqrt"(parameter_t) except+
    parameter_t cpp_erf_p "escape::erf"(parameter_t) except+
    
    parameter_t cpp_pow_p "escape::pow"(parameter_t, parameter_t) except+
    parameter_t cpp_min_p "escape::min"(parameter_t, parameter_t) except+
    parameter_t cpp_max_p "escape::max"(parameter_t, parameter_t) except+
    
    parameter_t cpp_tgamma_p "escape::tgamma"(parameter_t) except+
    parameter_t cpp_gammap_p "escape::gamma_p"(parameter_t, parameter_t) except+
    parameter_t cpp_gammaq_p "escape::gamma_q"(parameter_t, parameter_t) except+
    parameter_t cpp_tgammal_p "escape::tgamma_lower"(parameter_t, parameter_t) except+
    parameter_t cpp_tgammau_p "escape::tgamma_upper"(parameter_t, parameter_t) except+
    
    parameter_t cpp_cyl_bessel_j_p "escape::cyl_bessel_j"(parameter_t, parameter_t) except+
    
    parameter_t cpp_integral0_7 "escape::integral0<7>"  (functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    parameter_t cpp_integral0_15 "escape::integral0<15>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    parameter_t cpp_integral0_21 "escape::integral0<21>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    parameter_t cpp_integral0_31 "escape::integral0<31>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    parameter_t cpp_integral0_51 "escape::integral0<51>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    parameter_t cpp_integral0_61 "escape::integral0<61>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    
    functor_t cpp_integral_7 "escape::integral<7>"  (functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_15 "escape::integral<15>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_21 "escape::integral<21>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_31 "escape::integral<31>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_51 "escape::integral<51>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_61 "escape::integral<61>"(functor_t, variable_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    
    functor_t cpp_integral_param_7 "escape::integral<7>"  (functor_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_param_15 "escape::integral<15>"(functor_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_param_21 "escape::integral<21>"(functor_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_param_31 "escape::integral<31>"(functor_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_param_51 "escape::integral<51>"(functor_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    functor_t cpp_integral_param_61 "escape::integral<61>"(functor_t, parameter_t, parameter_t, parameter_t, double_setting_t, double_setting_t, int_setting_t) except+
    
    vector_t cpp_vector "escape::vector" (parameter_t, parameter_t, parameter_t) except+
    
cdef vector_t list_to_vector(name, value)
