from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.core.variable cimport variable_t
from escape.core.parameter cimport parameter_t, bool_parameter_t
from escape.core.functor cimport functor_t, bool_functor_t, cplx_functor_t
from escape.core.kernel cimport kernel_t
    
cdef extern from "escape/core.h" namespace "escape::core":

    functor_t cpp_const_functor_df "escape::_const_functor" (double, functor_t) except +
    functor_t cpp_const_functor_pf "escape::_const_functor<escape::functor_t, escape::functor_t>" (parameter_t, functor_t) except +
    functor_t cpp_const_functor_db "escape::_const_functor" (double, bool_functor_t) except +
    functor_t cpp_const_functor_pb "escape::_const_functor<escape::functor_t, escape::bool_functor_t>" (parameter_t, bool_functor_t) except +

    functor_t cpp_add_vv "escape::operator+" (variable_t, variable_t) except +
    functor_t cpp_add_dv "escape::operator+" (double, variable_t) except +
    functor_t cpp_add_vd "escape::operator+" (variable_t, double) except +
    functor_t cpp_add_pv "escape::operator+" (parameter_t, variable_t) except +
    functor_t cpp_add_vp "escape::operator+" (variable_t, parameter_t) except +
    functor_t cpp_add_fv "escape::operator+" (functor_t, variable_t) except +
    functor_t cpp_add_vf "escape::operator+" (variable_t, functor_t) except +
    functor_t cpp_add_fd "escape::operator+" (functor_t, double) except +
    functor_t cpp_add_df "escape::operator+" (double, functor_t) except +
    functor_t cpp_add_pf "escape::operator+" (parameter_t, functor_t) except +
    functor_t cpp_add_fp "escape::operator+" (functor_t, parameter_t) except +

    parameter_t cpp_add_pd "escape::operator+" (parameter_t, double) except +
    parameter_t cpp_add_dp "escape::operator+" (double, parameter_t) except +

    cplx_functor_t cpp_add_fc "escape::operator+" (functor_t, cplx_functor_t) except +
    cplx_functor_t cpp_add_f_dc "escape::operator+" (functor_t, double complex) except +
    cplx_functor_t cpp_add_c_dc "escape::operator+" (cplx_functor_t, double complex) except +
    cplx_functor_t cpp_add_vc "escape::operator+" (variable_t, cplx_functor_t) except +
    cplx_functor_t cpp_add_v_dc "escape::operator+" (variable_t, double complex) except +
    cplx_functor_t cpp_add_dc "escape::operator+" (double, cplx_functor_t) except +
    cplx_functor_t cpp_add_dc_c "escape::operator+" (double complex, cplx_functor_t) except +
    cplx_functor_t cpp_add_dc_f "escape::operator+" (double complex, functor_t) except +
    cplx_functor_t cpp_add_dc_v "escape::operator+" (double complex, variable_t) except +
    cplx_functor_t cpp_add_cd "escape::operator+" (cplx_functor_t, double) except +
    cplx_functor_t cpp_add_cp "escape::operator+" (cplx_functor_t, parameter_t) except +
    cplx_functor_t cpp_add_pc "escape::operator+" (parameter_t, cplx_functor_t) except +
    cplx_functor_t cpp_add_cv "escape::operator+" (cplx_functor_t, variable_t) except +
    cplx_functor_t cpp_add_cf "escape::operator+" (cplx_functor_t, functor_t) except +
    
    functor_t cpp_sub_vv "escape::operator-" (variable_t, variable_t) except +
    functor_t cpp_sub_dv "escape::operator-" (double, variable_t) except +
    functor_t cpp_sub_vd "escape::operator-" (variable_t, double) except +
    functor_t cpp_sub_pv "escape::operator-" (parameter_t, variable_t) except +
    functor_t cpp_sub_vp "escape::operator-" (variable_t, parameter_t) except +
    functor_t cpp_sub_fv "escape::operator-" (functor_t, variable_t) except +
    functor_t cpp_sub_vf "escape::operator-" (variable_t, functor_t) except +
    functor_t cpp_sub_fd "escape::operator-" (functor_t, double) except +
    functor_t cpp_sub_df "escape::operator-" (double, functor_t) except +
    functor_t cpp_sub_pf "escape::operator-" (parameter_t, functor_t) except +
    functor_t cpp_sub_fp "escape::operator-" (functor_t, parameter_t) except +
    
    parameter_t cpp_pow_p "escape::pow"(parameter_t, parameter_t) except+
    functor_t cpp_pow_f "escape::pow"(functor_t, functor_t) except+
    functor_t cpp_pow_vv "escape::pow"(variable_t, variable_t) except+
    functor_t cpp_pow_vf "escape::pow"(variable_t, functor_t) except+
    functor_t cpp_pow_fv "escape::pow"(functor_t, variable_t) except+

    parameter_t cpp_sub_pd "escape::operator-" (parameter_t, double) except +
    parameter_t cpp_sub_dp "escape::operator-" (double, parameter_t) except +

    cplx_functor_t cpp_sub_fc "escape::operator-" (functor_t, cplx_functor_t) except +
    cplx_functor_t cpp_sub_f_dc "escape::operator-" (functor_t, double complex) except +
    cplx_functor_t cpp_sub_c_dc "escape::operator-" (cplx_functor_t, double complex) except +
    cplx_functor_t cpp_sub_vc "escape::operator-" (variable_t, cplx_functor_t) except +
    cplx_functor_t cpp_sub_v_dc "escape::operator-" (variable_t, double complex) except +
    cplx_functor_t cpp_sub_dc "escape::operator-" (double, cplx_functor_t) except +
    cplx_functor_t cpp_sub_dc_c "escape::operator-" (double complex, cplx_functor_t) except +
    cplx_functor_t cpp_sub_dc_f "escape::operator-" (double complex, functor_t) except +
    cplx_functor_t cpp_sub_dc_v "escape::operator-" (double complex, variable_t) except +
    cplx_functor_t cpp_sub_cd "escape::operator-" (cplx_functor_t, double) except +
    cplx_functor_t cpp_sub_cp "escape::operator-" (cplx_functor_t, parameter_t) except +
    cplx_functor_t cpp_sub_pc "escape::operator-" (parameter_t, cplx_functor_t) except +
    cplx_functor_t cpp_sub_cv "escape::operator-" (cplx_functor_t, variable_t) except +
    cplx_functor_t cpp_sub_cf "escape::operator-" (cplx_functor_t, functor_t) except +


    
    functor_t cpp_mul_vv "escape::operator*" (variable_t, variable_t) except +
    functor_t cpp_mul_dv "escape::operator*" (double, variable_t) except +
    functor_t cpp_mul_vd "escape::operator*" (variable_t, double) except +
    functor_t cpp_mul_pv "escape::operator*" (parameter_t, variable_t) except +
    functor_t cpp_mul_vp "escape::operator*" (variable_t, parameter_t) except +
    functor_t cpp_mul_fv "escape::operator*" (functor_t, variable_t) except +
    functor_t cpp_mul_vf "escape::operator*" (variable_t, functor_t) except +
    functor_t cpp_mul_pf "escape::operator*" (parameter_t, functor_t) except +
    functor_t cpp_mul_fp "escape::operator*" (functor_t, parameter_t) except +
    functor_t cpp_mul_fd "escape::operator*" (functor_t, double) except +
    functor_t cpp_mul_df "escape::operator*" (double, functor_t) except +

    parameter_t cpp_mul_pd "escape::operator*" (parameter_t, double) except +
    parameter_t cpp_mul_dp "escape::operator*" (double, parameter_t) except +

    cplx_functor_t cpp_mul_fc "escape::operator*" (functor_t, cplx_functor_t) except +
    cplx_functor_t cpp_mul_f_dc "escape::operator*" (functor_t, double complex) except +
    cplx_functor_t cpp_mul_c_dc "escape::operator*" (cplx_functor_t, double complex) except +
    cplx_functor_t cpp_mul_vc "escape::operator*" (variable_t, cplx_functor_t) except +
    cplx_functor_t cpp_mul_v_dc "escape::operator*" (variable_t, double complex) except +
    cplx_functor_t cpp_mul_dc "escape::operator*" (double, cplx_functor_t) except +
    cplx_functor_t cpp_mul_dc_c "escape::operator*" (double complex, cplx_functor_t) except +
    cplx_functor_t cpp_mul_dc_f "escape::operator*" (double complex, functor_t) except +
    cplx_functor_t cpp_mul_dc_v "escape::operator*" (double complex, variable_t) except +
    cplx_functor_t cpp_mul_cd "escape::operator*" (cplx_functor_t, double) except +
    cplx_functor_t cpp_mul_cp "escape::operator*" (cplx_functor_t, parameter_t) except +
    cplx_functor_t cpp_mul_pc "escape::operator*" (parameter_t, cplx_functor_t) except +
    cplx_functor_t cpp_mul_cv "escape::operator*" (cplx_functor_t, variable_t) except +
    cplx_functor_t cpp_mul_cf "escape::operator*" (cplx_functor_t, functor_t) except +
    

    functor_t cpp_div_vv "escape::operator/" (variable_t, variable_t) except +
    functor_t cpp_div_dv "escape::operator/" (double, variable_t) except +
    functor_t cpp_div_vd "escape::operator/" (variable_t, double) except +
    functor_t cpp_div_pv "escape::operator/" (parameter_t, variable_t) except +
    functor_t cpp_div_vp "escape::operator/" (variable_t, parameter_t) except +
    functor_t cpp_div_fv "escape::operator/" (functor_t, variable_t) except +
    functor_t cpp_div_vf "escape::operator/" (variable_t, functor_t) except +
    functor_t cpp_div_pf "escape::operator/" (parameter_t, functor_t) except +
    functor_t cpp_div_fp "escape::operator/" (functor_t, parameter_t) except +
    functor_t cpp_div_fd "escape::operator/" (functor_t, double) except +
    functor_t cpp_div_df "escape::operator/" (double, functor_t) except +

    parameter_t cpp_div_pd "escape::operator/" (parameter_t, double) except +
    parameter_t cpp_div_dp "escape::operator/" (double, parameter_t) except +

    cplx_functor_t cpp_div_fc "escape::operator/" (functor_t, cplx_functor_t) except +
    cplx_functor_t cpp_div_f_dc "escape::operator/" (functor_t, double complex) except +
    cplx_functor_t cpp_div_c_dc "escape::operator/" (cplx_functor_t, double complex) except +
    cplx_functor_t cpp_div_vc "escape::operator/" (variable_t, cplx_functor_t) except +
    cplx_functor_t cpp_div_v_dc "escape::operator/" (variable_t, double complex) except +
    cplx_functor_t cpp_div_dc "escape::operator/" (double, cplx_functor_t) except +
    cplx_functor_t cpp_div_dc_c "escape::operator/" (double complex, cplx_functor_t) except +
    cplx_functor_t cpp_div_dc_f "escape::operator/" (double complex, functor_t) except +
    cplx_functor_t cpp_div_dc_v "escape::operator/" (double complex, variable_t) except +
    cplx_functor_t cpp_div_cd "escape::operator/" (cplx_functor_t, double) except +
    cplx_functor_t cpp_div_cp "escape::operator/" (cplx_functor_t, parameter_t) except +
    cplx_functor_t cpp_div_pc "escape::operator/" (parameter_t, cplx_functor_t) except +
    cplx_functor_t cpp_div_cv "escape::operator/" (cplx_functor_t, variable_t) except +
    cplx_functor_t cpp_div_cf "escape::operator/" (cplx_functor_t, functor_t) except +

    functor_t cpp_neg_var "escape::operator-" (variable_t) except +

    bool_functor_t cpp_more_vv "escape::gt" (variable_t, variable_t) except +
    bool_functor_t cpp_more_vp "escape::gt" (variable_t, parameter_t) except +
    bool_functor_t cpp_more_vd "escape::gt" (variable_t, double) except +
    bool_functor_t cpp_more_vf "escape::gt" (variable_t, functor_t) except +
    bool_functor_t cpp_more_pv "escape::gt" (parameter_t, variable_t) except +
    bool_functor_t cpp_more_dv "escape::gt" (double, variable_t) except +
    bool_functor_t cpp_more_fv "escape::gt" (functor_t, variable_t) except +
    bool_functor_t cpp_more_fp "escape::gt" (functor_t, parameter_t) except +
    bool_functor_t cpp_more_fd "escape::gt" (functor_t, double) except +
    bool_functor_t cpp_more_pf "escape::gt" (parameter_t, functor_t) except +
    bool_functor_t cpp_more_df "escape::gt" (double, functor_t) except +

    bool_parameter_t cpp_more_pp "escape::gt" (parameter_t, parameter_t) except +
    bool_parameter_t cpp_more_pd "escape::gt" (parameter_t, double) except +
    bool_parameter_t cpp_more_dp "escape::gt" (double, parameter_t) except +

    bool_functor_t cpp_less_vv "escape::lt" (variable_t, variable_t) except +
    bool_functor_t cpp_less_vp "escape::lt" (variable_t, parameter_t) except +
    bool_functor_t cpp_less_vd "escape::lt" (variable_t, double) except +
    bool_functor_t cpp_less_vf "escape::lt" (variable_t, functor_t) except +
    bool_functor_t cpp_less_pv "escape::lt" (parameter_t, variable_t) except +
    bool_functor_t cpp_less_dv "escape::lt" (double, variable_t) except +
    bool_functor_t cpp_less_fv "escape::lt" (functor_t, variable_t) except +
    bool_functor_t cpp_less_fp "escape::lt" (functor_t, parameter_t) except +
    bool_functor_t cpp_less_fd "escape::lt" (functor_t, double) except +
    bool_functor_t cpp_less_pf "escape::lt" (parameter_t, functor_t) except +
    bool_functor_t cpp_less_df "escape::lt" (double, functor_t) except +

    bool_parameter_t cpp_less_pp "escape::lt" (parameter_t, parameter_t) except +
    bool_parameter_t cpp_less_pd "escape::lt" (parameter_t, double) except +
    bool_parameter_t cpp_less_dp "escape::lt" (double, parameter_t) except +

    bool_functor_t cpp_more_equal_vv "escape::ge" (variable_t, variable_t) except +
    bool_functor_t cpp_more_equal_vp "escape::ge" (variable_t, parameter_t) except +
    bool_functor_t cpp_more_equal_vd "escape::ge" (variable_t, double) except +
    bool_functor_t cpp_more_equal_vf "escape::ge" (variable_t, functor_t) except +
    bool_functor_t cpp_more_equal_pv "escape::ge" (parameter_t, variable_t) except +
    bool_functor_t cpp_more_equal_dv "escape::ge" (double, variable_t) except +
    bool_functor_t cpp_more_equal_fv "escape::ge" (functor_t, variable_t) except +
    bool_functor_t cpp_more_equal_fp "escape::ge" (functor_t, parameter_t) except +
    bool_functor_t cpp_more_equal_fd "escape::ge" (functor_t, double) except +
    bool_functor_t cpp_more_equal_pf "escape::ge" (parameter_t, functor_t) except +
    bool_functor_t cpp_more_equal_df "escape::ge" (double, functor_t) except +
    
    bool_parameter_t cpp_more_equal_pp "escape::ge" (parameter_t, parameter_t) except +
    bool_parameter_t cpp_more_equal_pd "escape::ge" (parameter_t, double) except +
    bool_parameter_t cpp_more_equal_dp "escape::ge" (double, parameter_t) except +

    bool_functor_t cpp_less_equal_vv "escape::le" (variable_t, variable_t) except +
    bool_functor_t cpp_less_equal_vp "escape::le" (variable_t, parameter_t) except +
    bool_functor_t cpp_less_equal_vd "escape::le" (variable_t, double) except +
    bool_functor_t cpp_less_equal_vf "escape::le" (variable_t, functor_t) except +
    bool_functor_t cpp_less_equal_pv "escape::le" (parameter_t, variable_t) except +
    bool_functor_t cpp_less_equal_dv "escape::le" (double, variable_t) except +
    bool_functor_t cpp_less_equal_fv "escape::le" (functor_t, variable_t) except +
    bool_functor_t cpp_less_equal_fp "escape::le" (functor_t, parameter_t) except +
    bool_functor_t cpp_less_equal_fd "escape::le" (functor_t, double) except +
    bool_functor_t cpp_less_equal_pf "escape::le" (parameter_t, functor_t) except +
    bool_functor_t cpp_less_equal_df "escape::le" (double, functor_t) except +

    bool_parameter_t cpp_less_equal_pp "escape::le" (parameter_t, parameter_t) except +
    bool_parameter_t cpp_less_equal_pd "escape::le" (parameter_t, double) except +
    bool_parameter_t cpp_less_equal_dp "escape::le" (double, parameter_t) except +

    bool_functor_t cpp_equal_vv "escape::eq" (variable_t, variable_t) except +
    bool_functor_t cpp_equal_vp "escape::eq" (variable_t, parameter_t) except +
    bool_functor_t cpp_equal_vd "escape::eq" (variable_t, double) except +
    bool_functor_t cpp_equal_vf "escape::eq" (variable_t, functor_t) except +
    bool_functor_t cpp_equal_pv "escape::eq" (parameter_t, variable_t) except +
    bool_functor_t cpp_equal_dv "escape::eq" (double, variable_t) except +
    bool_functor_t cpp_equal_fv "escape::eq" (functor_t, variable_t) except +
    bool_functor_t cpp_equal_fp "escape::eq" (functor_t, parameter_t) except +
    bool_functor_t cpp_equal_fd "escape::eq" (functor_t, double) except +
    bool_functor_t cpp_equal_pf "escape::eq" (parameter_t, functor_t) except +
    bool_functor_t cpp_equal_df "escape::eq" (double, functor_t) except +

    bool_parameter_t cpp_equal_pp "escape::eq" (parameter_t, parameter_t) except +
    bool_parameter_t cpp_equal_pd "escape::eq" (parameter_t, double) except +
    bool_parameter_t cpp_equal_dp "escape::eq" (double, parameter_t) except +

    bool_functor_t cpp_nequal_vv "escape::neq" (variable_t, variable_t) except +
    bool_functor_t cpp_nequal_vp "escape::neq" (variable_t, parameter_t) except +
    bool_functor_t cpp_nequal_vd "escape::neq" (variable_t, double) except +
    bool_functor_t cpp_nequal_vf "escape::neq" (variable_t, functor_t) except +
    bool_functor_t cpp_nequal_pv "escape::neq" (parameter_t, variable_t) except +
    bool_functor_t cpp_nequal_dv "escape::neq" (double, variable_t) except +
    bool_functor_t cpp_nequal_fv "escape::neq" (functor_t, variable_t) except +
    bool_functor_t cpp_nequal_fp "escape::neq" (functor_t, parameter_t) except +
    bool_functor_t cpp_nequal_fd "escape::neq" (functor_t, double) except +
    bool_functor_t cpp_nequal_pf "escape::neq" (parameter_t, functor_t) except +
    bool_functor_t cpp_nequal_df "escape::neq" (double, functor_t) except +
    
    bool_parameter_t cpp_nequal_pp "escape::neq" (parameter_t, parameter_t) except +
    bool_parameter_t cpp_nequal_pd "escape::neq" (parameter_t, double) except +
    bool_parameter_t cpp_nequal_dp "escape::neq" (double, parameter_t) except +

cdef class variable_obj:
    cdef variable_t * _ptr
    cdef set_ptr(self, variable_t * ptr)
    @staticmethod
    cdef variable_obj from_ptr(variable_t *_ptr)

cdef class parameter_obj:
    cdef parameter_t * _ptr
    cdef set_ptr(self, parameter_t * ptr)
    @staticmethod
    cdef parameter_obj from_ptr(parameter_t *_ptr)

cdef class bool_parameter_obj:
    cdef bool_parameter_t * _ptr
    cdef set_ptr(self, bool_parameter_t * ptr)
    @staticmethod
    cdef bool_parameter_obj from_ptr(bool_parameter_t *_ptr)

cdef class bool_functor_obj:
    cdef bool_functor_t * _ptr
    cdef set_ptr(self, bool_functor_t * ptr)
    @staticmethod
    cdef bool_functor_obj from_ptr(bool_functor_t *_ptr)
    
cdef class functor_obj:
    cdef functor_t * _ptr
    cdef set_ptr(self, functor_t * ptr)
    @staticmethod
    cdef functor_obj from_ptr(functor_t *_ptr)
    
cdef class cplx_functor_obj:
    cdef cplx_functor_t * _ptr
    cdef set_ptr(self, cplx_functor_t * ptr)
    @staticmethod
    cdef cplx_functor_obj from_ptr(cplx_functor_t *_ptr)
 
cdef class kernel_obj:
    cdef kernel_t * _ptr
    cdef set_ptr(self, kernel_t * ptr)
    @staticmethod
    cdef kernel_obj from_ptr(kernel_t *_ptr)
    
    