from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

cimport cpython.ref as cpy_ref

from escape.core.array cimport double_array_t
from escape.core.model cimport modelstack_t
from escape.core.parameter cimport parameter_t
from escape.core.setting cimport double_setting_t, int_setting_t, bool_setting_t, string_setting_t


cdef extern from "escape/core.h" namespace "escape::core":

    cdef cppclass optimizer_t:
        optimizer_t() except+
        optimizer_t(optimizer_t) except+

        void call "operator()" (c_bool) except+

        c_string status_msg() except +
        size_t status_code() except +
        size_t num_of_iterations() except +
        size_t num_of_evaluations() except +
        double best_cost() except +
        void stop() except +
        void wait_async() except +
        double_array_t initial_parameters() except +
        modelstack_t modelstack() except +
        void reset_to_initial() except +
        void shake() except +
        void bind_python_object(cpy_ref.PyObject*) except +
        
        c_string magic() except+
        
        c_string name() except +
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        

    optimizer_t cpp_lm_algorithm "escape::lm_algorithm" (
        c_string, modelstack_t,
        double_setting_t, double_setting_t,
        double_setting_t, int_setting_t,
        int_setting_t, int_setting_t) except+
    
    optimizer_t cpp_de_algorithm "escape::de_algorithm"(
        c_string, modelstack_t, int_setting_t,
        string_setting_t,
        int_setting_t,
        double_setting_t,
        double_setting_t,
        double_setting_t,
        double_setting_t,
        int_setting_t,
        int_setting_t,
        int_setting_t)  except+


cdef class optimizer_obj:
    cdef optimizer_t * _ptr
    cdef list _initial_values
    cdef list _costs_list
    cdef float _initial_cost
    cdef object _initialized_method
    cdef object _finalized_method
    cdef object _iteration_method
    cdef set_ptr(self, optimizer_t * ptr)
