from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

cdef extern from "escape/core.h" namespace "escape::core":
    cdef cppclass parameter_t:
        parameter_t()
        parameter_t(parameter_t) except +
        double call "operator()" () except +
        c_bool set_value(double, c_bool) except +

        double value() except +
        double scale() except +

        c_string id() except +
        c_string units() except +
        
        void set_fixed(c_bool) except +
        c_bool is_fixed() except +
        double error() except +

        c_bool set_min(double) except +
        c_bool set_max(double) except +
        c_bool set_limits(double, double) except +
        c_bool set_physical_min(double) except +
        c_bool set_physical_max(double) except +
        c_bool set_physical_limits(double, double) except +

        double min(c_bool) except +
        double max(c_bool) except +

        c_bool is_independent() except +

        parameter_t operator + (parameter_t) except +
        parameter_t operator - (parameter_t) except +
        parameter_t operator - () except +
        parameter_t operator * (parameter_t) except +
        parameter_t operator / (parameter_t) except +
        c_string name() except +
        void set_name(c_string) except +
        
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +


    cdef cppclass bool_parameter_t:
        bool_parameter_t()
        bool_parameter_t(bool_parameter_t) except +

        double call "operator()" () except +
        
        c_string id() except +
        
        bool_parameter_t logic_and "operator &&" (bool_parameter_t) except +
        bool_parameter_t logic_or "operator ||" (bool_parameter_t) except +
        bool_parameter_t logic_not "operator !" () except +

        c_string name() except +
        void set_name(c_string) except +
        
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +

    parameter_t cpp_parameter "escape::par" (
        c_string, double, double, double, double,
        double, c_bool fixed, double, double, c_string) except +
    parameter_t cpp_value "escape::value" (double) except +

    parameter_t cpp_conditional_param "escape::conditional" (bool_parameter_t, parameter_t, parameter_t) except +

