from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

cimport cpython.ref as cpy_ref

from escape.core.array cimport double_array_t
from escape.core.model cimport modelstack_t
from escape.core.data cimport datastack_t
from escape.core.parameter cimport parameter_t
from escape.core.setting cimport double_setting_t, int_setting_t, bool_setting_t, string_setting_t


cdef extern from "escape/core.h" namespace "escape::core":

    cdef cppclass regressor_t:
        regressor_t() except+
        regressor_t(regressor_t) except+
        
        double train (c_bool reset_data) except+
        void call "operator()" (datastack_t X) except+

        void stop() except +
        
        size_t ntests() except +
        size_t nsamples() except +
        
        modelstack_t modelstack() except +
        void reset() except +
        void shake() except +
        datastack_t test(size_t idx) except +
        
        void bind_python_object(cpy_ref.PyObject*) except +
        
        c_string name() except +
        c_string magic() except +
        
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        
    regressor_t cpp_python_regressor "escape::python_regressor" (
        c_string, modelstack_t, int_setting_t, int_setting_t) except+
    

cdef class regressor_obj:
    cdef regressor_t * _ptr
    cdef object _fit_method
    cdef object _predict_method
    cdef object _score_method
    cdef object _norm_method
    cdef object _noisify_method
    cdef object _stop_method
    cdef object _regressor
    cdef size_t _test_idx
    cdef set_ptr(self, regressor_t * ptr)
