from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

cdef extern from "escape/core.h" namespace "escape::core":
    cdef cppclass setting_t[T]:
        setting_t()
        setting_t(setting_t) except +
        T get () except +
        void set (T, c_bool ) except +
        c_string id() except +
        c_string units() except +
        c_string label() except +
        c_bool is_readonly() except +

ctypedef setting_t[int] int_setting_t
ctypedef setting_t[double] double_setting_t
ctypedef setting_t[c_string] string_setting_t
ctypedef setting_t[c_bool] bool_setting_t


cdef class int_setting_obj:
    cdef int_setting_t * _ptr
    cdef set_ptr(self, int_setting_t * ptr)
    @staticmethod
    cdef int_setting_obj from_ptr(int_setting_t *_ptr)
    
    
cdef class double_setting_obj:
    cdef double_setting_t * _ptr
    cdef set_ptr(self, double_setting_t * ptr)
    @staticmethod
    cdef double_setting_obj from_ptr(double_setting_t *_ptr)
    
    
cdef class bool_setting_obj:
    cdef bool_setting_t * _ptr
    cdef set_ptr(self, bool_setting_t * ptr)
    @staticmethod
    cdef bool_setting_obj from_ptr(bool_setting_t *_ptr)
   
    
cdef class string_setting_obj:
    cdef string_setting_t * _ptr
    cdef set_ptr(self, string_setting_t * ptr)
    @staticmethod
    cdef string_setting_obj from_ptr(string_setting_t *_ptr)
    


cdef extern from "escape/core.h" namespace "escape":
    int_setting_t cpp_create_int_setting "escape::setting<int>" (c_string, int, c_string, c_bool) except +
    int_setting_t cpp_wrap_int_setting "escape::setting<int>" (int_setting_t) except +
    double_setting_t cpp_create_double_setting "escape::setting<double>" (c_string, double, c_string, c_bool) except +
    double_setting_t cpp_wrap_double_setting "escape::setting<double>" (double_setting_t) except +
    bool_setting_t cpp_create_bool_setting "escape::setting<bool>" (c_string, c_bool, c_string, c_bool) except +
    bool_setting_t cpp_wrap_bool_setting "escape::setting<bool>" (bool_setting_t) except +
    string_setting_t cpp_create_string_setting "escape::setting<std::string>" (c_string, c_string, c_string, c_bool) except +
    string_setting_t cpp_wrap_string_setting "escape::setting<bool>" (string_setting_t) except +
    