from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.core.functor cimport cplx_functor_t
from escape.core.parameter cimport parameter_t
from escape.core.variable cimport variable_t

from escape.scattering.geometry cimport geometry_t, vertex_t

cdef extern from "escape/scattering.h" namespace "escape":
    cplx_functor_t cpp_ff_box "escape::ffbox" (c_string, variable_t, variable_t, variable_t, 
                                       parameter_t, parameter_t, parameter_t,
                                       parameter_t, parameter_t, parameter_t) except+
                                       
    cplx_functor_t cpp_ff_pyramid "escape::ffpyramid" (
        c_string, variable_t, variable_t, variable_t,
        parameter_t, parameter_t, parameter_t, parameter_t,
        vertex_t, vertex_t,
        parameter_t, parameter_t, parameter_t) except+
        
    cplx_functor_t cpp_ff_shape3d "escape::ffshape3d" (
        c_string, variable_t, variable_t, variable_t,
        geometry_t,
        parameter_t, parameter_t, parameter_t) except+
        
    cplx_functor_t cpp_ff_sphere "escape::ffsphere" (
        c_string, variable_t, variable_t, variable_t,
        parameter_t r, parameter_t sw) except+
                                       
                                       
                                       
                                       
