from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string
from escape.core.parameter cimport parameter_t
from escape.core.setting cimport string_setting_t, int_setting_t


cdef extern from "escape/scattering.h" namespace "escape::scattering":
    cdef cppclass geometry_t:
    
        geometry_t()
        geometry_t(geometry_t) except +
        
        geometry_t operator+(geometry_t) except +
        geometry_t operator-(geometry_t) except +
        geometry_t operator*(geometry_t) except +
        geometry_t operator-() except +
        
        c_string to_x3d() except +
        c_string name() except +
        void set_name(c_string) except +
        parameter_t parameter(size_t) except +
        size_t num_of_params() except +
        
    cdef cppclass vertex_t:
        vertex_t()


cdef extern from "escape/core.h" namespace "escape":
    geometry_t cpp_gbox "escape::gbox"(c_string,
        parameter_t, parameter_t, parameter_t, string_setting_t)
    
    geometry_t cpp_gsphere "escape::gsphere"(c_string,
        parameter_t, int_setting_t, int_setting_t, string_setting_t)
    
    geometry_t cpp_gcylinder "escape::gcylinder"(c_string,
        parameter_t, vertex_t, vertex_t, int_setting_t, string_setting_t)
    
    geometry_t cpp_gcone "escape::gcone"(c_string,
        parameter_t, parameter_t, int_setting_t, string_setting_t)

    geometry_t cpp_gpyramid "escape::gpyramid"(c_string,
        parameter_t, parameter_t, parameter_t, parameter_t, 
        vertex_t , vertex_t, string_setting_t)
    
    vertex_t cpp_vertex "escape::vertex"(
        parameter_t, parameter_t, parameter_t)
    
    
#cdef class vertex_obj:
#     cdef vertex_t * _ptr
#     cdef set_ptr(self, vertex_t * ptr)
#     @staticmethod
#     cdef vertex_obj from_ptr(vertex_t *_ptr)
#     
    
cdef class geometry_obj:
    cdef geometry_t * _ptr
    cdef set_ptr(self, geometry_t * ptr)
    @staticmethod
    cdef geometry_obj from_ptr(geometry_t *_ptr)
    
    
cdef vertex_t list_to_vertex(name, object value)
    
    