from libcpp cimport bool as c_bool
from libcpp.string cimport string as c_string

from escape.scattering.layer cimport multilayer_t
from escape.core.functor cimport functor_t
from escape.core.parameter cimport parameter_t
from escape.core.variable cimport variable_t
from escape.core.math cimport vector_t


cdef extern from "escape/scattering.h" namespace "escape":
    functor_t cpp_specrefl_matrix_v "escape::specrefl_matrix" (c_string, variable_t, multilayer_t) except+    
    functor_t cpp_specrefl_dynsr_v "escape::specrefl_dynsr" (c_string, variable_t, multilayer_t) except+
    functor_t cpp_specrefl_parratt_v "escape::specrefl_parratt" (c_string, variable_t, multilayer_t) except+
    functor_t cpp_specrefl_kinematic_v "escape::specrefl_kinematic" (c_string, variable_t, multilayer_t) except+
    
    functor_t cpp_pnr_specrefl_v "escape::pnr_specrefl" (c_string, variable_t, multilayer_t, vector_t, parameter_t, parameter_t) except+
    
    functor_t cpp_specrefl_matrix_f "escape::specrefl_matrix" (c_string, functor_t, multilayer_t) except+    
    functor_t cpp_specrefl_dynsr_f "escape::specrefl_dynsr" (c_string, functor_t, multilayer_t) except+
    functor_t cpp_specrefl_parratt_f "escape::specrefl_parratt" (c_string, functor_t, multilayer_t) except+
    functor_t cpp_specrefl_kinematic_f "escape::specrefl_kinematic" (c_string, functor_t, multilayer_t) except+
    functor_t cpp_pnr_specrefl_f "escape::pnr_specrefl" (c_string, functor_t, multilayer_t, vector_t, parameter_t, parameter_t) except+
    